// Save chrome, return null image file via CGI "$Revision: 1.4 $"
//
// Based http://cscene.org/CS6/CS6-07.html 14 Dec 2001
// W. B. Langdon

// make using g++ -o harvest harvest.cc #eg on occasion

// 21 Dec 2001

//Modifications (in reverse order)

// WBL 18 Mar 2004 Make happier to www users. Rename dump www_header
// WBL  8 Jan 2004 Make more robust against spiders.
//                 Log errors to debug and back to internet invoker

// WBL 29 Dec 2001 append to live population


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <time.h>

#define strcasecmp strcmp

#if _WIN32
#include <fcntl.h>
#include <io.h>

#define strcasecmp stricmp
#endif

void cgiError()
{
    // Most simple error handling
    cout << endl;
    exit(0);
}

void www_header()
{
  //cout << "Content-Type: " << "image/gif" << endl;
  //cout << endl;
  //cout.write(buf, count);
  cout << "Content-Type: text/plain\n\n";
}

int hexdigit(char c) {
  return 
    (c>='A' && c<='F')? c - 'A'+10 :
    (c>='a' && c<='f')? c - 'a'+10 :
    (c>='0' && c<='9')? c - '0'    :  -1000; //error
}

void header(ostream& out) {
  time_t start;
  time (&start);
  char* timestr = ctime(&start); timestr[strlen(timestr)-1]='\0';
  out << timestr << " ";
  out << getenv("REMOTE_HOST") << " ";
  out << getenv("REMOTE_ADDR") << "|"; /* << flush;*/
}

void error_text2(ostream& out, char* const text, 
		int const badchar, char* const imgparm) {
  if(!out) return;
  out<<"harvest failed ";
  header(out);
  char* querystr = getenv("QUERY_STRING");     // get Internet text 
  out<<" '"<<querystr<<"' ";
  if(badchar) out<<"badchar ";
  out<<" '"<<imgparm<<"' ";
  out<<text<<" ";
  out<<"harvest exit"<<endl;
}

void error_text(ostream& out, char* const text, 
		int const badchar, char* const imgparm) {
  www_header();
  error_text2(cout,text,badchar,imgparm); //send error message back to www
  error_text2(out, text,badchar,imgparm);
}

int main()
{
    //debug<<"\nreflect main()"<<flush;
#if _WIN32
    // Standard I/O is in text mode by default; since we intend
    // to send binary image data to standard output, we have to
    // set it to binary mode.
    // Error handling is tricky to say the least, so we have none.
    _fmode = _O_BINARY;
    if (_setmode(_fileno(stdin), _fmode) == -1) {}
    if (_setmode(_fileno(stdout), _fmode) == -1) {}
#endif

    // First, we get the text to send back
    char* querystr = getenv("QUERY_STRING");
    //debug<<" "<<querystr<<flush;
    //int ampersand=0; tried to validate on having two or more 
    //BUT Jan 2004 have 43 such cases in seed.pop.
    //instead treat "<" as first char as special case
    int badchar = 1;
    char* p  = querystr ? strstr(querystr, "hex=") : 0;
    char* imgparm = ""; /*no garbage collection will be attempted*/
    int length;
    if(p) {
      //debug<<"hex "<<p<<flush;
      p += 4;
      int const lenp   = strlen(p);
      length = lenp/2;
      //debug<<" "<<length<<" "<<flush;
      imgparm    = new char[length+1]; 
      imgparm[0] = '\0';
      int j=0;
      for(int i=0; i<length; i++) {
	const int c = 16*hexdigit(*p++) + hexdigit(*p++);
	if(c>31) imgparm[j++] = c; //save non-control codes
	if(i==0) badchar = ((length*2!=lenp)||c=='<')? 1 : 0; //validity check
	if(c<0)  badchar = 1;
	//debug<<imgparm[i]<<flush;
      }
      imgparm[j] = '\0';
    }
    if(!badchar) {
      ofstream pop ("seed.pop",ios::app);
      if(!pop) {
	ofstream debug ("debug",ios::app);
	error_text(debug,"failed to open seed.pop",badchar,imgparm);
      }
      else {
	www_header(); // Start to send ok message back
	header(pop);
	pop<<imgparm<<endl;
	cout<<"THANKYOU Flake ("<<length<<"bytes) saved in global population!";
      }
    }
    else {
      ofstream debug ("debug",ios::app);
      error_text(debug,"bad seed",badchar,imgparm);
    }

    //debug<<"reflect exit"<<endl;
    return 0;
}

