#!/opt/ucl/bin/perl5
#copy from http://hjem.get2net.dk/bnielsen/lsystems.html 15 Dec 2001
#$Revision: 1.16 $
#WBL  4 Jun 2005 Use cmdline to indicate call by oneseed.awk
#WBL 23 Mar 2004 Combined lsys2.perl and lsys.perl. Just use log
#WBL 21 Mar 2004 Surpress LOG2 when not being used via the www
#                (For now, at least, effectively all the time)
#WBL 18 Mar 2004 Use LOG2
#WBL  8 Jan 2004 BUGFIX setting of rules. Avoid having LOG open a long time
#WBL 29 Nov 2003 increase timeout it=4 shortest ~4 secs?
#WBL 28 Nov 2003 add timeout based on elapsed time rather than moves
#use strict;

my($stack,$str,$newstr) = ("","","");
my($a,$v,$p,$x,$y) = (0,0,0,0,0);
my($pi) = 4 * atan2(1,1);
my($it,$sc) = (0,0);
my(%draw,%rules);

my($buffer) =("");
#my($pairs) =("");
#my($name) =("");
#my($value,$FORM) =("","");


sub timeout() {
    $end = time();
#   print "now ",$end," started ",$start," difference ",($end-$start),"\n";
    return ($end-$start>60); #seconds NB "greater than" (not >=)
}

sub timeout_message {
#TO
    print "timeout_message called\n";
    print "P P0 5 0\n";
    print "P P1 5 10\n";
    print "L P0 P1\n";
    print "P P0 0 10\n";
    print "P P1 10 10\n";
    print "L P0 P1\n";
    print "P P0 12 0\n";
    print "P P1 19 0\n";
    print "L P0 P1\n";
    print "P P0 19 0\n";
    print "P P1 19 10\n";
    print "L P0 P1\n";
    print "P P0 19 10\n";
    print "P P1 12 10\n";
    print "L P0 P1\n";
    print "P P0 12 10\n";
    print "P P1 12 0\n";
    print "L P0 P1\n";
}
sub jp {
  my $d = $_[0];
  $x = $x + $d * cos($a*$pi/180);
  $y = $y + $d * sin($a*$pi/180);
  print "P P$p $x $y\n";
}

sub mv {
  my $d = $_[0];
  $p = 1 - $p;
  $x = $x + $d * cos($a*$pi/180);
  $y = $y + $d * sin($a*$pi/180);
  print "P P$p $x $y\n";
  print "L P0 P1\n";
}

sub push {
  $stack = "$x:$y:$a:$stack";
}
  
sub pop {
  ($x,$y,$a,$stack) = ($1,$2,$3,$4) if 
    $stack =~ /^([^:]+):([^:]+):([^:]+):(.*)/;
  print "P P$p $x $y\n";
}
  
# prints the ENV stuff on submitter
sub printWho{
local($pname) = "printWho";
print "$pname\n" if ($debug);
    local($FILE) = @_;
    local($time) = time();
    local($timestamp) = &showtime($time);

    printf($FILE "%%%s %-15s %s ", $timestamp, "$ENV{REMOTE_HOST} ($ENV{REMOTE_ADDR})");
    printf($FILE "%s ", "$ENV{HTTP_REFERER} $ENV{SCRIPT_NAME} $ENV{HTTP_USER_AGENT}");
}
#<J.Andrews@cs.ucl.ac.uk>
#Date: Wed, 20 Dec 2000 11:24:09 +0000
sub showtime {
local($xx,@y);
local($xsec,$xmin,$xhour,$xdate,$xmon,$xyear,$xday);
$xx=$_[0];
@y=gmtime($xx);
$xsec=$y[0];
$xmin=$y[1];
$xhour=$y[2];
$xdate=$y[3];
$xmon=(Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$y[4]];
$xyear=$y[5] + 1900;
$xday=(Sun,Mon,Tue,Wed,Thu,Fri,Sat)[$y[6]];
return(sprintf("%02d:%02d:%02d GMT %s %s %s %s",$xhour,$xmin,$xsec,$xday,$xdate,$xmon,$xyear));
}

$start = time();

%draw = ('F','mv(1);', '+','$a+=$v;', '-','$a-=$v;',
         'f','jp(1);','[','push();', ']', 'pop();');

# Koch snefnug
$v = 60; $str = "F++F++F"; $it = 2; $sc = 5;
#%rules = ('F', "F-F++F-F");

################################################################ 
# Process Query 
################################################################ 
	print "$pname: $FORM{'author'}\n" if ($debug);

$first = shift; #get start of command line
#if($ENV{'QUERY_STRING'} ne "") {
if($ENV{'QUERY_STRING'} ne "" and $first eq "") {#if WWW and no cmdline
    $www = 1;
    $buffer = $ENV{'QUERY_STRING'};
#   print "Content/type: text/plain\n\n"; not used by pl2ppm.perl
}
else {
    $www = 0;
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    $buffer = <STDIN>;
}
print "buffer ",$buffer,"[",$ENV{'QUERY_STRING'},"]","[",$first,"]","\n";
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
#    $value =~ tr/+/ /;
#    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#    $FORM{$name} = $value;
#    print $FORM{$name},$name,$value,"\n";
    if($name eq "v")   {$v=$value;}
    if($name eq "str")   {$str=$value;}
    if($name eq "it")    {$it=$value;}
    if($name eq "sc")    {$sc=$value;}
    if($name eq "rules") {
        $value =~ s/[\(\)\'\s]//g; #remove syntatic sugar from rules
        my @v = split(",",$value); 
	for(my $i=0;$i<$#v;) {
	    $rules{"@v[$i]"} = @v[$i+1]; 
#	    printf("v[%s]=%s  ",$i,@v[$i]);
#	    printf("v[%s]=%s\n",$i+1,@v[$i+1]);
	    $i = $i+2;
	}
    }
}
if(scalar keys %rules==0) {
# Koch snefnug
    %rules = ('F', 'F-F++F-F');
}

print "grammar ";
printf("v=%s str=%s it=%d sc=%f rules=(",$v,$str,$it,$sc);
foreach(keys %rules) {
    my $k=$_;
    printf("%s=>%s ",$k,$rules{$k});
} 
printf(")");
printf("\n\n");

$g_str = $str;
outer:foreach (1..$it) {
  $newstr = "";
  for $_ ((split(//,$str))) {
    $newstr .= $rules{$_} || $_;
    if(timeout()) {last outer;}
  }
  $str = $newstr;
#  print "str ",length($str),"\n";
}

print "TR 0 0 +$sc +$sc 0 0 0.00\n";
print "P P$p 0 0\n";
#print "$str\n";
for $_ ((split(//,$str))) {
  eval($draw{$_}) if defined $draw{$_};
  if(timeout()) {last;}
}
        if(timeout()) {timeout_message();}
	close(STDOUT);

if($www) {
	open(LOG,">>log") ||  &errorMessage("$pname:Can't open log: $!\n");
	printWho("LOG");
        printf(LOG ";_:%s:_;", "$ENV{QUERY_STRING} $ENV{'CONTENT_LENGTH'}");

        printf(LOG "v=%s str=%s it=%d sc=%f rules=(",$v,$g_str,$it,$sc);
        foreach(keys %rules) {
	    my $k=$_;
	    printf(LOG "%s=>%s ",$k,$rules{$k});
	}
        printf(LOG ")");

        printf(LOG " str %d ",length($str));
        printf(LOG "elapsed %d",time()-$start);
        if(timeout()) {
	    printf(LOG " TIMEDOUT");
	}
	printf(LOG "\n");
	close(LOG);
}

