#nawk script to display contents of seed.pop $Revision: 1.18 $
#
#WBL 18 Mar 2004 for batch operation on sonic. Based on seed.awk r1.3

#WBL 17 Apr 2005 Replace lsys with Rhino pfeiffer.js
#WBL 22 Mar 2004 Replace lsys2 with lsys. Tweak creator output
#                Extract name= from seed.pop
#WBL 21 Mar 2004 BUGFIX ensure get last char in each line of seed.pop
#                Plus other tweaks

#Inputs seed.pop

BEGIN { 	
    error = 0;
    if(html=="")      html     = "/tmp/wbl_pop.html";
    #timout ten minutes
    if(pfeiffer=="")  pfeiffer = "java -jar rhino/js.jar rhino/pfeiffer.js -t600";
#   if(mymachine=="") mymachine="solenoid.cs.ucl.ac.uk";

#   system_("pwd",21);

    s = gettime();
    split(s,t);
    last = sprintf("%s %s %s %s",t[4],t[3],t[2],t[6]);

    print "<html><head>"                                    > html;
    print "<title>"                                         > html;
    print "Most Popular in Global Population of Genetic Snowflakes" > html;
    print "</title>"                                        > html;
    print "<!--pop.awk $Revision: 1.18 $!-->"               > html;
    print "<body BGCOLOR=\"#7f7f7f\" LINK=\"#0000ff\""      > html;
    print " ALINK=\"#00ff00\" VLINK=\"#ff0000\""            > html;
    print " TEXT=\"#202080\">"                              > html;
    print "</head><body>"                                   > html;
}

(NF>0) { #pass through seed.pop
    n=index($0,"|");
    if(n<23) {
	input = $0;
	time[FNR] = "";
	creator[FNR] = "";
    }
    else {
	input = substr($0,n+1);
	time[FNR] = sprintf("%s %s&nbsp;%s %s",$4,$3,$2,$5);
	if(start=="") start = sprintf("%s %s %s",$3,$2,$5);
	split(substr($0,1,n-1),t2);
	s = (t2[6]!="(null)")? t2[6]:t2[7];
#insert spaces to break up input so HTML looks better.
	n3=split(s,t3,"."); s=t3[1];
	for(i=2;i<=n3;i++) {s=sprintf("%s. %s",s,t3[i]);}
	creator[FNR] = s;
    }
	n2=split(input,t2);
	pheno="";
	for(i=1;i<=n2;i++) {pheno=sprintf("%s%s",pheno,t2[i]);}
	name[FNR] = "";
	n2=split(pheno,t2,"&");
	for(i=1;i<=n2;i++) {
	    n3=split(t2[i],t3,"=");
	    if(t3[1]=="name") name[FNR] = t3[2];
	}
    if(!file_exists(ppm_file(FNR))) {
	print pheno                > input_file(FNR);
	close(input_file(FNR));
	s = sprintf("%s %s",pfeiffer,input_file(FNR));
	s = sprintf("%s\t>%s\n",s,ppm_file(FNR));
	system_(s,1);
	s = sprintf("rm %s",input_file(FNR));
	system_(s,2);
    }#create missing PPM
#insert spaces to break up input so HTML looks better.
    n3=split(input,t3,"&"); s=t3[1];
    for(i=2;i<=n3;i++) {s=sprintf("%s & %s",s,t3[i]);}
    lsys[FNR] = s;
}

END{
    print "<table border=1>"                                   > html;
    print "<caption><font size=+5>Global Population"           > html;
    print "</font></caption>"                                  > html;
    print "<tr><th>Votes</th>"                                 > html;
    print "<th>Flake</th>"                                     > html;
    print "<th colspan=3>Discovered by</th>"                   > html;
    print "<th>L-System</a></th>"                              > html;
    print "</tr>"                                              > html;

    for(i=1;i<=FNR;i++) {
	txt=read_file(ppm_file(i));
#	print i,ppm_file(i),length(txt);
	if(length(txt)>0) { #check for junk, eg timed out
	if(ppm[txt]=="") {
	    ppm[txt]==1;
	    first[txt]=i;
	    count++;
	}
	ppm[txt]++;
	duplicates[first[txt]] = sprintf("%s %s",duplicates[first[txt]],i);
	}
    }
    for(p in ppm) {
	#leading zeros on second data column make sort stable
	printf("%d %06d\n", ppm[p],first[p]) > sort_filein();
    }
    s = sprintf("sort -n -r %s > %s",sort_filein(),sort_fileout());
    system_(s,3);
    for(i=1;i<=count && error==0;i++) {
	status = getline test < sort_fileout();
	if(status!=1) {print "ERROR",status,i,sort_fileout(); error=11;}
	split(test,t);
	F = t[2]*1; #remove leading zeros
	printf("<!--")                                             > html;
	printf("Flake %s occurs %s times %s",F,t[1],duplicates[F]) > html;
	printf("!-->\n")                                           > html;
	if(!file_exists(gif_file(F))) {
	    s = sprintf("ppmtogif <%s 2>/dev/null",ppm_file(F));
	    s = sprintf("%s\t| giftool -rgb 0,0,0",s);
	    s = sprintf("%s\t>%s\n",s,gif_tmp(F));
	    system_(s,4);
	    if(error==0) {
	      s = sprintf("mv %s %s\n",gif_tmp(F),gif_file(F));
	      s = sprintf("%schmod o+r %s\n",s,gif_file(F));
	      s = sprintf("%schmod o-w %s\n",s,gif_file(F));
	      system_(s,5);
	    }
	}#create missing GIF

	printf("<td>%s</td>",t[1])                           > html;
	printf("<td><img src=\"%s\"></td>\n",gif_url(F))     > html;
	printf("<td>%s</td>\n",time[F])                      > html;
	printf("<td>%s</td>\n",substr(name[F],0,30))         > html;
	printf("<td>%s</td>\n",creator[F])                   > html;
	printf("<td>%s</td>",lsys[F])                        > html;
	printf("</tr>\n\n")                                  > html;
    }

    printf("<tr><td colspan=6>%d</td></tr>\n\n",FNR)             > html;
    printf("</table>\n")                                         > html;
    print "<p>Snow flakes saved between",start,"and",last        > html;
    print "by users of "                                         > html;
    print "<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer.html\">">html;
    print "pfeiffer.html</a><p>"                                 > html;
    print "<p><a href=\"overview.html\">Documentation.</a>"      > html;
    printf("<address>\n")                                        > html;
    printf("<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/\">") >html;
    printf("W.B.Langdon</a>\n")                                  > html;
    printf("<!--%d lines processed. Done %s!-->\n",FNR,gettime())> html;
    printf("</address></body></html>\n")                         > html;
    close(html);

    if(error==0 && count>0) {
      if(file_exists(live_file())) {
	s = sprintf("mv %s %s",live_file(),backup_file());
	system_(s,9);
      }
      if(error==0) {
	s = sprintf("mv %s %s",html,live_file());
	system_(s,10);
      }
    }


    s = sprintf("rm %s",sort_filein());
    system(s);
    s = sprintf("rm %s",sort_fileout());
    system(s);

#Dont try to clean up junk left previously 
#   s = sprintf("rm %s",input_file("*"));
#   print s;
#   system(s);
}

function system_(s,n) {
#   print s;
    status_ = system(s);
    if(status_!=0) {
      print "ERROR in system call",s,"status",status_;
      error = n;
    }
}
function file_exists(name) {
####http://www.faqs.org/faqs/computer-lang/awk/faq/
    return (system("test -r " name) == 0)
}
function read_file(name, s_) {
    getline s_ < name;
    close(name);
    return (index(s_,"P3")==1)? read_file_P3(name) : read_file_P1(name);
}
function read_file_P1(name) {
    ans_ = "";
    i_ = 0;
    do {
	s_ = "";
	status_ = getline s_ < name;
	#skip time out errors etc
	if(index(s_,"#")!=1)
	    ans_ = (ans_=="")? s_ : sprintf("%s\n%s",ans_,s_);
#	print i_++,status_,length(s_),name;
    } while(status_>0);
    close(name);
    return ans_;
}
function read_file_P3(name, ans_,i_,s_,status_,n,nmax,t,i,hash) {
#P3 too big, spend too much time garbage collecting.
#so return hash of file contents not whole of file
    ans_ = "";
    i_ = 0;
    do {
	s_ = "";
	status_ = getline s_ < name;
	i_++;
        #save header lines in full but skip comment
	if(i_<=5){
	    if(index(s_,"#")!=1) {
		ans_ = (ans_=="")? s_ : sprintf("%s %s",ans_,s_);}
	} else {
	    n=split(s_,t);
	    if(nmax<n) nmax=n;
	    for(i=1;i<=n;i++) {
		hash[i] += lshift(t[i],i_%24);
	    }
	}
    } while(status_>0);
    close(name);
    for(i=1;i<=nmax;i++) ans_ = sprintf("%s %x",ans_,hash[i]);
#   print i_++,ans_,name;
    return ans_;
}
function input_file(i) {
    return sprintf("/tmp/wbl_%d.tmp",i);
}
function ppm_file(i) {
    return sprintf("/tmp/wbl_%d.ppm",i);
}
function sort_filein() {
    return sprintf("/tmp/wbl_.dat",i);
}
function sort_fileout() {
    return sprintf("/tmp/wbl_.srt",i);
}
function live_file() {
#   return sprintf("pop.html");
    return sprintf("../public_html/pfeiffer/pop.html");
}
function backup_file() {
#   return sprintf("pop_old.html");
    return sprintf("../public_html/pfeiffer/pop_old.html");
}
function gif_file(i) {
    return sprintf("../public_html/pfeiffer/pop/seed_%d.gif",i);
}
function gif_tmp(i) {
#    return sprintf("/tmp/seed_%d.gif",i);
    return sprintf("/tmp/wbl_%d.gif",i);
}
function gif_url(i) {
    return sprintf("http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer/pop/seed_%d.gif",i);
}

function gettime() {
#    Thu Mar 18 15:31:50 GMT 2004 format
    now = "";
    "date" | getline now;
    close("date");
    return now;
}
