//Javascript file to interpret one Lindenmayer grammar $Revision: 1.14 $
//and output it as a portable bit map
// W. B. Langdon
// http://www.cs.essex.ac.uk/staff/W.Langdon
// Written on 16 April 2006 Based on pfeiffer_local.html r1.113

// 17 June 2006 give up on trying to run as part of cgi-script on www
// server. Instead run under rsh/C++ intepretter on sonic
// remove mention of readFile not needed

load("../public_html/Pnglet.js","../public_html/lsys.js","rhino/pbm.js");

var D = new Array();
    D[0]=0;
    D[1]=1;
    D[2]=2;
    D[3]=3;
    D[4]=4;
    D[5]=5;
    D[6]=6;
    D[7]=7;
    D[8]=8;
    D[9]=9;
    D["a"]=10;
    D["b"]=11;
    D["c"]=12;
    D["d"]=13;
    D["e"]=14;
    D["f"]=15;
function unHex(string) {
    var a="";
    for(var i=0;i<string.length;i+=2) {
      var h1 = D[string.substr(i,1)]*16;
      var h2 = D[string.substr(i+1,1)];
      var x = h1+h2;
      a += (x>=32 && x<127)? String.fromCharCode(x) : "";
    }
    return a;
}
<!-- "http://javascriptsource.com">The JavaScript Source -->
<!-- ONE STEP TO INSTALL SHIMMERING LINKS: -->
<!-- This script and many more are available free online at -->
<!-- The JavaScript Source!! http://javascript.internet.com -->
<!-- Original:  Phil Reeve  (curry_master@myrealbox.com) -->
<!-- Web Site:  http://www.philreeve.com -->
///////////////////Hex Conversions/////////////////////
// convert a single digit (0 - 16) into hex
function enHex(aDigit)
{
    return("0123456789ABCDEF".substring(aDigit, aDigit+1))
}
function toHex(n) //8bit version!
{
   return(/*enHex((0xf00000 & n) >> 20) +
            enHex((0x0f0000 & n) >> 16) +
            enHex((0x00f000 & n) >> 12) +
            enHex((0x000f00 & n) >>  8) +*/
            enHex((0x0000f0 & n) >>  4) +
            enHex((0x00000f & n) >>  0));
}

//Non dynamic parameters
eve = new Object();
eve.chrome = "v=60&str=F++F++F & it=2 & sc =5 & rules=('F','F-F++F-F')&"+ //Koch snefnug
             "w= 1&wf=1.316074&" + //3**(0.25)
	     "sf=1.732051&"      + //3**(0.5)
	     "vf=5";               //deginc

eve.v=60; eve.str=""; eve.it=0; eve.sc=5; //last ditch defaults
eve.w=1;  eve.wf =1;  eve.sf=1; eve.vf=0;
parse_chrome2(eve.chrome,eve);

function cleanchrome(text1) { //prepare to send as ?URL
//var whitespace = " \t\r\n";
  var text2='';

  for (var i=0;i<text1.length;i++) {
    var c = text1.charCodeAt(i);
    if(c > 32 && c < 128) { //discard control codes
        text2 += text1.charAt(i);
    }
  }
  return text2;
}

  function colour_map(string,F) {
//  defaultStatus = "#";
    F.colours = new Array(); 
    var c = cleanchrome(string);
    var h = c.split("#");
    for(var i=0; i<h.length; i++) {
      var s = h[i].replace(/[^0-9a-fA-F]/g,"");
      for(;s.length>0; s=s.substr(6)) {
        var n = parseInt(s.substr(0,6),16);
	if(!isNaN(n)) {
          var map = F.colours[F.colours.length] = new Array();
	  for(var k=2; k>=0; k--) { map[k] = n & 0xff; n = n >> 8;}
/*	  defaultStatus += "'"+s.substr(0,6)+"'"+"-"+
.                           map[0].toString(16)+" "+
.                           map[1].toString(16)+" "+
.                           map[2].toString(16)+" ";
*/
	}
      }
    }
//  defaultStatus += ""+F.colours.length;
  }

  function expand_chrome(newchrome,F) {
        colour_map(newchrome,F);

        parse_chrome(newchrome,F);

	F.cmds=D01(F.it,F.str,F.rules);
  }//end expand_chrome

  function embryo_log(start,err,newchrome,F,a,b,c,png_) {
    F.time = (new Date().getTime())-start;
    return cleanchrome(newchrome)+":_;"+
//	          "E="+err+";Fit="+F.fit+";"+
//		  ((a>=0)? "an="+Flake[a].n+";af="+fit[a].value+";" : "")+
//		  ((b>=0)? "bn="+Flake[b].n+";bf="+fit[b].value+";" : "")+
	          "v="+F.v+";str="+F.str+";"+
		  "it="+F.it+";sc="+F.sc+";"+
		  "w="+F.w+";wf="+F.wf+";sf="+F.sf+";vf="+F.vf+";"+
		  "rules=("+F.rules_+");"+
		  (F.str? "len="+F.str.length+";" : "")+
		  (F.cmds? "cmds="+F.cmds.length+";" : "")+
		  "elapsed="+F.time+
		  ";w="+F.width+";h="+F.height+";";
//		  (F.nset? "nset="+F.nset.join():"")+
//		  ";to="+timedout+";"+
//		  c+";"+
//		  ((png_==null)? "": 
//		  ((png_==SVG)? "svg": png_? "png":"xbm")+"["+F.n+"]");
//		  F.cmds;
  }//end embryo_log

  function embryo(u,newchrome,a,b,c) {
    var start = new Date().getTime();
    F = new Object();

    expand_chrome(newchrome,F);

    var comment =   newchrome+"\n"+
		  ((a>=0)? "an="+Flake[a].n+";af="+fit[a].value+";" : "")+
		  ((b>=0)? "bn="+Flake[b].n+";bf="+fit[b].value+";" : "")+
	          "v="+F.v+";str="+F.str+";"+
		  "it="+F.it+";sc="+F.sc+";"+
		  "w="+F.w+";wf="+F.wf+";sf="+F.sf+";vf="+F.vf+";"+
		  "rules=("+F.rules_+");"+
		  (F.str? "len="+F.str.length+";" : "")+
		  c+";"
    F.pixmap = evalstring(F,F.cmds,F.colours,"");

    F.width  = 1+F.pixmap.maxx-F.pixmap.minx;
    F.height = 1+F.pixmap.maxy-F.pixmap.miny;
    F.comment=embryo_log(start,"ok",newchrome,F,a,b,c,"");
    return F;
  }//end embryo

  function parse_rules(string,f) {
    var value = string.replace(/[\(\)\s]/g,"");
    var v_ = value.split(",");
    //text[i] += " R"+name[0]+"value="+value+" nparams="+v_.length/2;
    for(var j=0; j<v_.length;) {
      //for colour we need ' So remove ' only from even v_[j]
      //15 Mar 2004 D01 only matches 1 char strings. Note longer
      //strings have no effect. 
      f.rules[v_[j].replace(/[\']/g,"").substr(0,1)] = 
                                            (j+1<v_.length)? v_[j+1] : "";
      f.rulesset = 1;
      j += 2;
    }//endforeach part of rules
    //text[i] += " rulesset="+rulesset;
  }//end parse_rules

  function format_rules_(f) {
    f.rules_ = "";
    for(var keys in f.rules) {
      if(f.rules_!="") {f.rules_ += ",";}
      f.rules_ += keys+"=>";
      if(f.rules[keys]) f.rules_ += f.rules[keys];
    } 
  }

  function parse_chrome2(string,f) {//parse but do not supply defaults
    f.rules = new Object();
    f.rulesset=0;
    var c= cleanchrome(string);
    //as lsys.perl r1.11
    var pairs = c.split("&");
    for(pair in pairs) {
      var name = pairs[pair].split("=");
      var name1;
      var n;
      if(name.length>1) {
	name1 = name[1];
	n     = parseFloat(name[1]);
	if(isNaN(n)) n=0; //as lsys.perl
      }
      else {
	name1 =""; //as lsys.perl
	n=0;       //as lsys.perl
      }
      if(name[0]=="v"  )      {f.v  =n;}
      if(name[0]=="vf"  )     {f.vf  =n;}
      if(name[0]=="str")      {f.str=name1}
      if(name[0]=="it" )      {f.it =n;}
      if(name[0]=="sc" )      {f.sc =n;}
      if(name[0]=="sf" )      {f.sf =n;}
      if(name[0]=="w"  )      {f.w  =n;}
      if(name[0]=="wf" )      {f.wf =n;}
      if(name[0]=="rules")    {parse_rules(name1,f);}
    }//endforeach pairs
  }

  function parse_chrome(string,f) {
    f.v = eve.v; f.str = eve.str; f.it = eve.it; f.sc = eve.sc;
    f.w = eve.w; f.wf  = eve.wf;  f.sf = eve.sf; f.vf = eve.vf;
    parse_chrome2(string,f);
    if(f.rulesset==0) {f.rules = eve.rules;}
    format_rules_(f);

    f.side = f.sc*0.2;
  }

var limit =0;//zero disables it, was needed when pnglet.output was called
var limit_=0;//zero disables it
var timedout;
  function timeout(timeout_start) {
    if(limit_==0) return false;
    var now = new Date().getTime();
    return ((now-timeout_start) > limit_);
}
function print_help() {
  print("One shot version of http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer.html")
  print("Converts one Lindenmayer grammar into a portable bit map graphics file");
  print("Grammar is read from QUERY_STRING environment variable or command line ");
  print("-tnnn ensures runs for no more than nnn seconds");
  print("P3 picture written to standard out");
  print("Under java (Rhino) first argument can be file holding grammar");
  print("pfeiffer.js $Revision: 1.14 $");
}

//environment seems to work with spidermonkey but not rhino
var net_input = environment["QUERY_STRING"];
//print(net_input);
if(arguments.length==0) print_help();
else {
  var hex     = false;
  var comment = false;
  var chrome  = "";
  for(var active=0; active<arguments.length; active++) {
  if((s=arguments[active].split(/-t/)).length==2){
    limit_=s[1]*1000;
  }
  else if(arguments[active]=="-x"){
    hex=true;
    net_input=true; //assume we are being run inresponse to cgi script
  }
  else if(arguments[active]=="-c"){
    comment=true;
    if(limit_==0) limit_=100;
  } else {
  //For use with spidermonkey to get readFile needed to have built js with:
  //gmake -f Makefile.ref JS_HAS_FILE_OBJECT=1
  //however that failed saying
  //"jsfile.c", line 94: cannot find include file: "prio.h"
  //"jsfile.c", line 95: cannot find include file: "prerror.h"
  //"jsfile.c", line 240: syntax error before or at: PRFileDesc
  //Bug 335652 bugzilla.mozilla.org
  //may be this fix will help?
  //https://bugzilla.mozilla.org/show_bug.cgi?id=213257
  //var t = readFile(arguments[0]);

    //Read grammar from command line
    var chrome; 
    if(hex) chrome = unHex(arguments[active]);
    else {
	 chrome = readFile(arguments[active]);
	 if(chrome.length==0) chrome = arguments[active];
	 }
    break;
  }//endif
  }//endfor commendline

  //Grow grammar into graphics commands and then into picture
  var Flake = embryo(false,chrome,-1,-1,0);

  //Convert picture and then output it as pbm
  //Since Pnglets implements polygon we use it to generate sparse pixmap
  var pnglet = pnglet_data(Flake.pixmap,Flake,Flake.colours);

  if(comment) {
    var last = arguments.length-1;
    var text = (hex)? unHex(arguments[last]) : arguments[last];
    print(text+" pfeiffer.js $Revision: 1.14 $ "+limit_+" ;_:"+Flake.comment);
  } 
  else if(timedout && (!net_input)) print("#timedout! "+timedout);
  else {
    var comment = "pfeiffer.js $Revision: 1.14 $ "+limit_+" "+chrome+
                  ";"+F.comment;
    print_pbm(pnglet.data,Flake.width,Flake.height,Flake.colours,comment);
  }
}//endif help()


