#nawk script to display contents of seed.pop $Revision: 1.7 $
#
#WBL 29 Jul 2005 Put link to pfeiffer
#WBL  4 Jun 2005 Remove generation of missing .gifs to oneseed.awk
#WBL 22 Mar 2004 Replace lsys2.perl by lsys.perl
#                Extract name= from seed.pop
#WBL 18 Mar 2004 for online operation
#WBL  9 Aug 2003 based on halloffame.awk r1.3
#WBL 27 Jan 2002
#
#Inputs seed.pop seed.pop

BEGIN { 	
    start = gettime();
    timeout = 10;
    top = 10;
#   if(mymachine=="") mymachine="solenoid.cs.ucl.ac.uk";

    print "<html><head>";
    print "<title>";
    print "Top in Global Population of Genetic Snowflakes";
    print "</title>";
    print "<!--seed.awk $Revision: 1.7 $",start,"!-->";
    print "<body BGCOLOR=\"#7f7f7f\" LINK=\"#0000ff\"";
    print " ALINK=\"#00ff00\" VLINK=\"#ff0000\"";
    print " TEXT=\"#202080\">";
    print "</head><body>";
    print "<H1>Snow flakes saved by users of ";
    print "<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer.html\">";
    print "pfeiffer.html</a></H1>";
}

(FNR==1) {file++;}

(file==1 && (n=index($0,"|"))>23) { #first pass through seed.pop
    lastline = FNR;
    lastday = sprintf("%s %s %s",$3,$2,$5);
#   print lastline,file,lastday
}

(file>1 && (n=index($0,"|"))>23 &&                        #2nd pass seed.pop
  ((FNR>lastline-top) || sprintf("%s %s %s",$3,$2,$5)==lastday) &&
  elapsed()<=timeout) { 
    if(first=="") first = FNR;
    input = substr($0,n+1);
    n2=split(input,t2);
    pheno="";
    for(i=1;i<=n2;i++) {pheno=sprintf("%s%s",pheno,t2[i]);}
    ok[FNR] = (file_exists(gif_file(FNR)));
    time[FNR] = sprintf("%s %s&nbsp;%s",$4,$3,$2);
    split(substr($0,1,n-1),t2);
#insert spaces to break up input so HTML looks better.
    s = (t2[6]!="(null)")? t2[6]:t2[7];
    n3=split(s,t3,"."); s=t3[1];
    for(i=2;i<=n3;i++) {s=sprintf("%s. %s",s,t3[i]);}
    creator[FNR] = s;
#insert spaces to break up input so HTML looks better.
    n3=split(input,t3,"&"); s=t3[1];
    for(i=2;i<=n3;i++) {s=sprintf("%s & %s",s,t3[i]);}
    lsys[FNR] = s;
    name[FNR] = "";
    n2=split(pheno,t2,"&");
    for(i=1;i<=n2;i++) {
	n3=split(t2[i],t3,"=");
	if(t3[1]=="name") name[FNR] = t3[2];
    }
}

END{
    print "<table>";
    print "<caption><font size=+5>";
    print "Top of Global Snowflake Population";
    print "</font></caption>";
    print "<th>N</th>";
    print "<th>Flake</th>";
    print "<th>Created</th>";
    print "<th>Name</th>";
    print "<th>Computer</th>";
    print "<th>L-System</a></th>";
    print "</tr>";

    for(l=lastline;file>1 && l>=first;l--) { #reverse order
	    printf("<tr>");
	    printf("<td>%d</td><td>",l);
	    if(ok[l]) {
		printf("<img src=\"%s\">",gif_url(l)); }
	    else if(newgifs<3) {#limit www server peak load
		printf("<img src=\"%s\"></td>\n",new_gif_url(l));
		newgifs++;
	    } else {
		#href to new_gif_url not useful as get white on white!
		#printf("<a href=\"%s\">timed out</a>",new_gif_url(l));
		printf("timed out. Try refresh?");
	    }
	    printf("</td>\n");
	    printf("<td>%s</td>",time[l]);
	    printf("<td>%s</td>",substr(name[l],0,30));
	    printf("<td>%s</td>",creator[l]);
	    printf("<td>%s</td>",lsys[l]);
	    printf("</tr>\n");
    }

    print "</table>";
    print "<p>Snow flakes saved by users of ";
    print "<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer.html\">";
    print "pfeiffer.html</a><p>";
    print "<p><a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer/overview.html\">Documentation.</a>";
#   printf("Server time %s seconds\n",elapsed());
    printf("<address>\n");
    printf("<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/\">");
    printf("W.B.Langdon</a>\n");
    printf("</address></body></html>\n");

}

function file_exists(name) {
####http://www.faqs.org/faqs/computer-lang/awk/faq/
    return (system("test -r " name) == 0)
}
function gif_file(i) {
    return sprintf("../public_html/pfeiffer/pop/seed_%d.gif",i);
}
function gif_url(i) {
    return sprintf("http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer/pop/seed_%d.gif",i);
}
function new_gif_url(i) {
    return sprintf("http://www.cs.ucl.ac.uk/cgi-bin/staff/W.Langdon/oneseed.bat?%d",i);
}

function secs(string) {
    split(string,t_);
    split(t_[4],t__,":");
    return ((t__[1]*60)+(t__[2]*60))+t__[3]; #hack ignore midnight
}
function elapsed() {
    sec1 = secs(start); 
    sec2 = secs(gettime()); 
    return sec2-sec1;
}
function gettime() {
#    Thu Mar 18 15:31:50 GMT 2004 format
    now = "";
    "date" | getline now;
    close "date";
    return now;
}
