//JavaScript Rotate $Revision: 1.1 $ based on Open GL
//W. B. Langdon 4 Feb 2004
//http://www.khronos.org/opengles/documentation/html/glRotate.html

function glRotate(angle,x,y,z /*axis*/) {
  //var x=axis.x; var y=axis.y; var z=axis.z;
  //Normalise x,y,z
  var x2 = x*x;
  var y2 = y*y;
  var z2 = z*z;
  var w2 = x*x + y*y + z*z;
  if(w2!=1) {
    x2 /= w2;
    y2 /= w2;
    z2 /= w2;
    var w=Math.sqrt(w2);
    x  /= w;
    y  /= w;
    z  /= w;
  }
  angle *= Math.PI/180;
  var c = Math.cos(angle); var cc = 1-c;
  var s = Math.sin(angle);

  var M = new Array(); 
  M[0] = new Array(); M[1]= new Array();  M[2]= new Array();    M[3]=new Array;

  M[0][0]= x2*cc+c;   M[0][1]=x*y*cc-z*s; M[0][2]=x*z*cc+y*s; //M[0][3]
  M[1][0]=x*y*cc+z*s; M[1][1]= y2*cc+c;   M[1][2]=y*z*cc-x*s; //M[1][3]
  M[2][0]=x*z*cc-y*s; M[2][1]=y*z*cc+x*s; M[2][2]= z2*cc+c;   //M[2][3]
/*M[3][0]=          ; M[3][1]=;           M[3][2]=;*/           M[3][3]=1;

  return M;
}
/*********************************************************************
M[
(	
x2 (1 - c) + c 	xy (1 - c) - zs 	xz (1 - c) + ys 	0
xy (1 - c) + zs 	y2 (1 - c) + c 	yz (1 - c) - xs 	0
xz (1 - c) - ys 	yz (1 - c) + xs 	z2 (1 - c) + c 	0
0 	0 	0 	1
	)

Where c = cos (angle) , s = sin (angle) , and || (x, y, z) || = 1, (if not, the GL will normalize this vector).
}

Name

glRotatef , glRotatex - multiply the current matrix by a rotation matrix
C Specification

void glRotatef(GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
void glRotatex(GLfixed angle, GLfixed x, GLfixed y, GLfixed z)

Parameters

angle

    Specifies the angle of rotation, in degrees.
x, y, z

    Specify the x, y, and z coordinates of a vector, respectively.

Description

glRotate produces a rotation of angle degrees around the vector (x, y, z) . The current matrix (see glMatrixMode) is multiplied by a rotation matrix with the product replacing the current matrix, as if glMultMatrix were called with the following matrix as its argument:

(	
x2 (1 - c) + c 	xy (1 - c) - zs 	xz (1 - c) + ys 	0
xy (1 - c) + zs 	y2 (1 - c) + c 	yz (1 - c) - xs 	0
xz (1 - c) - ys 	yz (1 - c) + xs 	z2 (1 - c) + c 	0
0 	0 	0 	1
	)

Where c = cos (angle) , s = sin (angle) , and || (x, y, z) || = 1, (if not, the GL will normalize this vector).

If the matrix mode is either GL_MODELVIEW or GL_PROJECTION, all objects drawn after glRotate is called are rotated. Use glPushMatrix and glPopMatrix to save and restore the unrotated coordinate system.
Notes

This rotation follows the right-hand rule, so if the vector (x, y, z) points toward the user, the rotation will be counterclockwise.
*********************************************************************/
