// D01 Lindenmayer System $Revision: 1.27 $
// W. B. Langdon
// http://www.cs.ucl.ac.uk/staff/W.Langdon
// Written on Jan 2004 (based on lsys.perl r1.11)
// itself copied from http://hjem.get2net.dk/bnielsen/lsystems.html 15 Dec 2001
// You may use this if you keep this copyright notice intact
// --------------------
// Tested with Mozilla Firebird and IE5.00. 
// Pnglet does NOT work with IE5.0 or IE6.0
// Netscape 4 not tried with Pnglet. NS4 unstable with pfeiffer_local.
//   (Also NS4 gives extra vertical lines at lefthand margin of XBM images).

//WBL 17 Apr 2006   Ensure compatible with Rhino R1.6r2
//WBL 11 Nov 2005   Ensure do not generate bad SVG when c2 is not valid
//WBL 25 Aug 2005   (Nearly) full LD0 support. 
//                  Ensure SVG polygon sets bounding box
//WBL 31 July 2005  Start adding SVG support
//WBL 24 Mar 2004   Merge PNG and XBM versions
//WBL 13 March 2004 Support colour and more Turtle commands
//                  Trap popping either empty stack

// move nset from pixmap to new xbm_pixmap argument dims
// create separate rotate_pixmap
// Allow evalstring to take bounding box inputs 7
// Allow planar figure to be out of X-Y plane
// IE5 no "const" correct used of undefined

//hashtables see http://www.crockford.com/javascript/survey.html
//ppm see http://en2.wikipedia.org/wiki/Portable_Pixmap_File_Format
//        http://www-info2.informatik.uni-wuerzburg.de/mitarbeiter/wolfram/lehre/bildformate.html

//I have not been able to find any justification for need to invert
//bit map so trees grow upwards but it appears to be needed.


        /*http://www.adobe.com/svg/source/transform_js.html
	dont quite see how to do this yet.
        * This function sets the transform attribute of the "gradient_star"
        * SVG element to the indicated value.
        *
        function set_transform (value)
        {
                var svgobj;
                var svgdoc = document.transform.getSVGDocument();

                svgobj = svgdoc.getElementById('gradient_star');
                svgobj.setAttribute ('transform', value);
                if (document.transf.transform.value != value)
                        document.transf.transform.value = value;
        }
        * This function appends the indicated value to the existing
        * transform attribute of the "gradient_star" SVG element.
        *
        function add_transform (value)
        {
                var svgobj;
                var svgdoc = document.transform.getSVGDocument();

                svgobj = svgdoc.getElementById('gradient_star');
                var cur_transform = svgobj.getAttribute ('transform');
                svgobj.setAttribute ('transform', cur_transform + ' ' + value);
                document.transf.transform.value = cur_transform + ' ' + value;
        }
*/
//could not make sense of SVG skewX, skewY transforms
//so do simple thing.
function rotate_svg(pixmap,angle) {
  newpix = new Array; //y x for efficiency
  newpix.minx=0;
  newpix.maxx=0;
  newpix.miny=0;
  newpix.maxy=0;

    var M = glRotate(angle,0,0,1); //matrix for rotation about z-axis
    //following will tend to overestimate bounds
    set_bounds(M[0][0]*pixmap.minx+M[0][1]*pixmap.miny,
	       M[1][0]*pixmap.minx+M[1][1]*pixmap.miny,newpix);
    set_bounds(M[0][0]*pixmap.minx+M[0][1]*pixmap.maxy,
	       M[1][0]*pixmap.minx+M[1][1]*pixmap.maxy,newpix);
    set_bounds(M[0][0]*pixmap.maxx+M[0][1]*pixmap.miny,
	       M[1][0]*pixmap.maxx+M[1][1]*pixmap.miny,newpix);
    set_bounds(M[0][0]*pixmap.maxx+M[0][1]*pixmap.maxy,
	       M[1][0]*pixmap.maxx+M[1][1]*pixmap.maxy,newpix);


    //still in cartesian coordinates
    var bbox= "<!-- rotated by "+angle+" degrees "+
	      " "+Date()+"\n"+
              M[0][0]+","+M[0][1]+","+M[1][0]+","+M[1][1]+"\n"+
	      "new bbox "+
	      newpix.minx+" "+newpix.miny+" "+newpix.maxx+" "+newpix.maxy+"-->"

    var trans = "transform=\""+
                "translate("+(-newpix.minx)+","+newpix.maxy+") "+
	        "scale(1,-1) "+
	        "rotate("+angle+")\">";

    var h=pixmap.txt.indexOf("<g id=\"top\"");
    var h2=pixmap.txt.indexOf(">",h);
    if(h<0||h2<=h) {
      alert("no <g id=\"top\" in SVG,"+h+" "+h2); 
      return pixmap;}
    var x =pixmap.txt.indexOf("transform=",h);
    var header=pixmap.txt.substring(0,x);
    var x2=pixmap.txt.indexOf("\">",x);
    var tail = pixmap.txt.substring(h2+2);
    newpix.txt=header+trans+"\n"+bbox+"\n"+tail;
    return newpix;
}

function rotate(pixmap,M) {/*bitmap_output*/
  newpix = new Array; //y x for efficiency
  newpix.minx=0;
  newpix.maxx=0;
  newpix.miny=0;
  newpix.maxy=0;
  //noneed to center done externally by moving DIV to retain centering

  if(pixmap.polygon) {
    newpix.polygon = new Array(pixmap.polygon.length);
    for(var n = 0; n<pixmap.polygon.length; n++) {
      var poly  = pixmap.polygon[n];
      var newp  = newpix.polygon[n] = new Object;
      newp.line = poly.line;
      newp.fill = poly.fill;
      newp.x    = new Array(poly.x.length);
      newp.y    = new Array(poly.y.length);
      for(var i=0; i<poly.x.length;i++) {
        newp.x[i] = Math.round(M[0][0]*poly.x[i] + M[0][1]*poly.y[i]);
	newp.y[i] = Math.round(M[1][0]*poly.x[i] + M[1][1]*poly.y[i]);
        set_bounds(newp.x[i],newp.y[i],newpix);
      }
    }
//  defaultStatus += "rot"+newpix.polygon[0].line+","+newpix.polygon[0].fill;
  }

  for(var y in pixmap) {
    var m01y = M[0][1]*y;
    var m11y = M[1][1]*y;
    for(var x in pixmap[y]) {
      var x_ = Math.round(M[0][0]*x + m01y);
      var y_ = Math.round(M[1][0]*x + m11y);
      set_bounds(x_,y_,newpix);
      if(newpix[y_]==null) {newpix[y_] = new Array;}
      newpix[y_][x_] = pixmap[y][x];
    }
  }  
  return newpix;
}

function pnglet_data(pixmap,dims,cmap) {
 var timeout_start = new Date().getTime();
 var width  = 1+pixmap.maxx-pixmap.minx;
 var height = 1+pixmap.maxy-pixmap.miny;
//defaultStatus += "png_pixmap("+width+"x"+height+",dims)";

 //Limit size of image so pnglet.output does not exceed timeout limit
 //(Assume 50,000 pixels per elapsed second)
 var max_h = Math.ceil(limit*50/width); 
 if(limit!=0 && max_h<height) {
   height = max_h;
   timedout |= 4;
// defaultStatus += "to:"+timedout+" "+max_h;
 }
 var colours = new Array((cmap)? cmap.length+2 : 2);
//defaultStatus += "#"+colours.length;
 var png = new Pnglet(width, height, colours.length);
 colours[0] = png.color(0,0,0,0);  //Actually creates the colour palette
 colours[1] = png.color(255,255,255);
 for(var k=0; k<colours.length-2;k++) {
   colours[k+2] = png.color(cmap[k][0],cmap[k][1],cmap[k][2]); }

 //bit of a hack since polygons cannot be in right order wrt pixels
 if(pixmap.polygon) {
   for(var n = 0; n<pixmap.polygon.length; n++) {
     if(timeout(timeout_start)) {
       timedout |= 8;
//     defaultStatus += "top:"+timedout+" "+n;
       break;
     }
     var poly = pixmap.polygon[n];
     var count= poly.x.length;
     if(count>2) { //ignore badly formed polygons
       var c1   = colours[poly.line];
       var c2   = colours[poly.fill];
       X        = new Array(count);
       Y        = new Array(count);
//     defaultStatus += "pg"+c1+","+c2+"(";
       for(var i=0; i<count;i++) {//diff XY-conventions
         X[i] = poly.x[i] - pixmap.minx
	 Y[i] = pixmap.maxy - poly.y[i];
//	 defaultStatus += ""+X[i]+","+Y[i]+" "
       }
//     defaultStatus += ")";
       png.polygonA(c1,c2,X,Y);
//     if(count!=3) alert("Calling polygon with "+X.length+" points");
//     png.polygonNXY(c1,c2,count,
//                    function(i) {return X[i];},
//                    function(i) {return Y[i];});
     }
   }
 }

 for(y = pixmap.maxy ; y > pixmap.maxy-height; y--) {//start at top
   if(timeout(timeout_start)) {
     timedout |= 8;
//   defaultStatus += "toy:"+timedout+" "+(y-pixmap.maxy+height);
     break;
   }
   if(pixmap[y]) {
     for(var x in pixmap[y]) { //diff XY-conventions
       png.point(colours[pixmap[y][x]], x-pixmap.minx, pixmap.maxy-y);
     }//endfor
   }//endif
 }

if((timedout&(8+4))==(8+4)) {//already timeout despite reducing height
  var colours = new Array(3);
//defaultStatus += "FAKEX";
  var png = new Pnglet(5, 5, 3);
  colours[0] = png.color(0,0,0,0);  //Actually creates the colour palette
  colours[1] = png.color(255,255,255);
  colours[2] = png.color(1,1,1);
  for(y = 5 ; y > 0; y--) {//start at top
    png.point(colours[1],  y,5-y);
    png.point(colours[2],5-y,5-y);
  }
  dims.width  = 5;
  dims.height = 5;
//defaultStatus += "Pnglt";
  dims.nset  = new Array();
  return png;
}

 dims.width  = width;
 dims.height = height; //pixmap.maxy-y;
 return png;
}
function png_pixmap(pixmap,dims,cmap) {
  var pnglet = pnglet_data(pixmap,dims,cmap);

 //output takes lots of CPU time. On 350mHz 15478 pixels per second
 dims.nset  = new Array();
 return pnglet.output(dims.nset);
}

//http://webreference.com/programming/javascript/professional/chap21/1/6.html
//Memory Leaks and Garbage Collection (hence use of line...)

function xbm_heading(width,height) {
 return	"#define pfeiffer_width " +width+"\n"+
	"#define pfeiffer_height "+height+"\n"+
	"static char pfeiffer_bits[] = {";
}
function xbm_pixmap(pixmap,dims) {/*bitmap_output*/
 var timeout_start = new Date().getTime();
 var width  = 1+pixmap.maxx-pixmap.minx;
 var bw     = Math.ceil(width/8);
 dims.nset  = new Array();
 dims.nset[0] = 0;

 var body = "";
 var bitx =  new Array(1,2,4,8,16,32,64,128);
 var first = 1;
 var y;
 for(y = pixmap.maxy ; y >= pixmap.miny; y--) {//start at top
   if(timeout(timeout_start)) {
     timedout |= 4;
     break;
   }
   var c = new Array(bw);
   if(pixmap[y] == null) {;}
   else {
     for(var x in pixmap[y]) {
       var x_ = x-pixmap.minx;
       var cx_= x_ >> 3;
       var bx_= bitx[x_%8];
       if((c[cx_] & bx_)==0) {
         c[cx_] |= bx_;
	 dims.nset[0]++;
       }
     }//endfor
   }//endif
   //if(y==0||y==pixmap.maxy)document.writeln("xbm_pixmap y "+y+"<br>\n");
   var line = "";//reduce garbage collection load, esp Sun Netscape 4.61 
   for(var i = 0 ; i < bw ; i++) {
     if(first==0)   {line += ",\n";}
     else         first=0;
     var c_ = c[i];
     //if(y==0||y==pixmap.maxy)document.writeln("i "+i+" c_"+c_+"<br>\n");
     if(c_ == null) {line += "0x00";}
     else {
       if(c_<16)    {line += "0x0"+c_.toString(16);}
       else         {line += "0x" +c_.toString(16);}
     }
   }
   body += line;
 }
 body += "}";

 dims.width  = width;
 dims.height = pixmap.maxy-y;

 return xbm_heading(width,pixmap.maxy-y)+body;

}//end xbm_pixmap

function set_bounds(x,y,pixmap) {
  if(x<pixmap.minx) {pixmap.minx=Math.round(x);}
  if(x>pixmap.maxx) {pixmap.maxx=Math.round(x);}
  if(y<pixmap.miny) {pixmap.miny=Math.round(y);}
  if(y>pixmap.maxy) {pixmap.maxy=Math.round(y);}
}

function cmap2alpha(r,g,b) {
  //Frig all 24 bits of colour map to generate alpha channel.
  var x = (r ^ g) ^ b;
  var a = 0;
  var p = 128;
  var m = 1;
  for(var i = 0; i<8; i++) { //test lsb to msb
   if((m&x)!=0) a+=p;
   m *=2;
   p /=2.0;
  }
  a = a/255;
  //alert("cmap2alpha_("+r+","+g+","+b+") x="+x+" x1="+x1+" x2="+x2+" x3="+x3+" a="+a+" p="+p+" m="+m);
  return a;
}

/*from http://astronomy.swin.edu.au/~pbourke/fractals/lsys/
Symbols The following characters have a geometric interpretation.

Character        Meaning
   F	         Move forward by line length drawing a line
   f	         Move forward by line length without drawing a line
   +	         Turn left by turning angle
   -	         Turn right by turning angle
   |	         Reverse direction (ie: turn by 180 degrees)
   [	         Push current drawing state onto stack
   ]	         Pop current drawing state from the stack
   #	         Increment the line width by line width increment
   !	         Decrement the line width by line width increment
   @	         Draw a dot with line width radius
   {	         Open a polygon
   }	         Close a polygon and fill it with fill colour
   >	         Multiply the line length by the line length scale factor
   <	         Divide the line length by the line length scale factor
   &	         Swap the meaning of + and -
   (	         Decrement turning angle by turning angle increment
   )	         Increment turning angle by turning angle increment

WBL
& will not be implemented - used as separator
% cutoff
*/
function evalstring(params,commands,cmap,svgcomment) {
    //alert("evalstring("+params.v+" "+params.side+","+commands.length+","+cmap.length+","+svgcomment+")");
    var timeout_start = new Date().getTime();
    var time=0;

    var ncolours = cmap.length;
    if(!ncolours) ncolours =2; //black(transparent),white
    else          ncolours+=2;

    if(svgcomment) {
    var colours = new Array(ncolours);
    var alphas  = new Array(ncolours);
    colours[0] = "black";
    colours[1] = "white";
    alphas[0]  = 1;
    alphas[1]  = 1;
    for(var k=0; k<colours.length-2;k++) {
      colours[k+2]="#"+toHex(cmap[k][0])+toHex(cmap[k][1])+toHex(cmap[k][2]); 
      alphas[k+2] =cmap2alpha(cmap[k][0],cmap[k][1],cmap[k][2]);
    }
    }//end create fill colour map for SVG

    pixmap = new Array; //y x for efficiency
    pixmap.txt="";
    pixmap.minx=0;
    pixmap.maxx=0;
    pixmap.miny=0;
    pixmap.maxy=0;

    var stack = new Array;
    var sp=0;
    stack[sp] = new Object;
    stack[sp].x = 0;
    stack[sp].y = 0;
    stack[sp].a = 0;
    stack[sp].c = 1; //white stroke
    stack[sp].c2= 1; //white fill
    stack[sp].deg = params.v; 
    stack[sp].sc  = params.side; 
    stack[sp].w   = params.w;

    var pstck = new Array();
    var psp=0;
    pstck[psp] = new Object;
    pstck[psp].x = new Array();
    pstck[psp].y = new Array();
    pstck[psp].c = stack[sp].c;
    pstck[psp].c2= stack[sp].c2;
    pstck[psp].w = stack[sp].w;

    for(var l=0; l<commands.length; l++) {
	var c = commands.charAt(l);
	switch(c) { 	//do as switch rather than eval
	    case "F": {/*move();     */
	        var angle = stack[sp].a*Math.PI/180;
		var cos_ = Math.cos(angle);
		var sin_ = Math.sin(angle);
		var newx = stack[sp].x + stack[sp].sc*cos_;
		var newy = stack[sp].y + stack[sp].sc*sin_;
		set_bounds(stack[sp].x,stack[sp].y,pixmap);//assume distance>=0
		if(svgcomment) {
		  pixmap.txt +="<g id=\"F"+l+"\">\n";
		  if(stack[sp].w>=2) {//use rotated rectangle
		  var x= stack[sp].x;
		  var y= stack[sp].y;
		  var wcos2 = stack[sp].w*Math.cos(angle+Math.PI/2);
		  var wsin2 = stack[sp].w*Math.sin(angle+Math.PI/2);
		  set_bounds(x   +wcos2,   y+wsin2,pixmap);
		  set_bounds(newx+wcos2,newy+wsin2,pixmap);
		  pixmap.txt +="<g transform=\""+
		               "translate("+x+" "+y+")"+
			       " rotate("+stack[sp].a+")\">\n";
	          pixmap.txt +="<rect class=\"F\" x=\"0\" y=\"0\""+ 
			       " width=\"" +stack[sp].sc+"\""+
			       " height=\""+stack[sp].w +"\"";
		  if(stack[sp].c2>=0)
		  pixmap.txt +=" fill=\""          +colours[stack[sp].c2]+"\""+
			       " fill-opacity=\""  +alphas [stack[sp].c2]+"\"";
		  pixmap.txt +=" stroke=\""        +colours[stack[sp].c ]+"\""+
			       " stroke-opacity=\""+alphas [stack[sp].c ]+"\""+
			       " stroke-width=\"1\" />\n";
		  pixmap.txt +="</g>\n";
		  } else if(stack[sp].w>=0) {
		  pixmap.txt +="<line class=\"F\""+		  
			       " x1=\""+stack[sp].x+"\" y1=\""+stack[sp].y+"\""+
			       " x2=\""+newx+"\" y2=\""+newy+"\""+
			       " stroke=\""        +colours[stack[sp].c ]+"\""+
			       " stroke-opacity=\""+alphas [stack[sp].c ]+"\""+
			       " stroke-width=\""  +	    stack[sp].w  +"\" />\n";
		  }
		  pixmap.txt +="</g>\n";
		  }
		else {
		/* width only supported by SVG */
		for(var i=0; i<=stack[sp].sc;i++) {
		  var x_ = Math.round(stack[sp].x+i*cos_);
		  var y_ = Math.round(stack[sp].y+i*sin_);
		  if(pixmap[y_]==null) {pixmap[y_] = new Array;}
		  pixmap[y_][x_] = stack[sp].c;
		  if((time++)%100==0 && timeout(timeout_start)) {
		    set_bounds(x_,y_,pixmap);
		    timedout |= 2;
		    return pixmap;
		  }//endif timedout
		}
		}//endif SVG
		set_bounds(newx,       newy,       pixmap);//assume distance>=0
		stack[sp].x = newx;
		stack[sp].y = newy;
		break;
		}//end move
	    case "+": stack[sp].a += stack[sp].deg; break;
	    case "-": stack[sp].a -= stack[sp].deg; break;
	    case "G": /* as f ?*/
	    case "f": {//jump();     
	        var angle = stack[sp].a*Math.PI/180;
		var cos_ = Math.cos(angle);
		var sin_ = Math.sin(angle);
	        stack[sp].x += stack[sp].sc*cos_;
		stack[sp].y += stack[sp].sc*sin_;
		break;
		}//end jump
	    case "[": /*push();*/
	       var old = sp;
	       sp++;
	       if(stack[sp]==null) stack[sp] = new Object;
	       stack[sp].x = stack[old].x;
	       stack[sp].y = stack[old].y;
	       stack[sp].a = stack[old].a;
	       stack[sp].c = stack[old].c;
	       stack[sp].c2= stack[old].c2;
	       stack[sp].deg = stack[old].deg; 
	       stack[sp].sc  = stack[old].sc; 
	       stack[sp].w   = stack[old].w;
	       break;
	    case "]": /*pop();*/
	       if(sp>0) --sp; 
	       break;
	    case "{": /*push polygon */
	       psp++;
	       pstck[psp] = new Object;
	       pstck[psp].x = new Array();
	       pstck[psp].y = new Array();
	       pstck[psp].c = stack[sp].c;
	       pstck[psp].c2= stack[sp].c2;
	       pstck[psp].w = stack[sp].w;
//defaultStatus += "p{"+psp;
	       break;
	    case ".": 
	       pstck[psp].x[pstck[psp].x.length] = Math.round(stack[sp].x);
	       pstck[psp].y[pstck[psp].y.length] = Math.round(stack[sp].y);
	       set_bounds(stack[sp].x,stack[sp].y,pixmap);//assume will be used
	       break;
	    case "}": {/*pop polygon*/
	       if(svgcomment) {
	         pixmap.txt +="<g id=\"P"+l+"\">\n";
		 pixmap.txt +="<polygon class=\"P\" points=\"";
		 for(var i = 0; i<pstck[psp].x.length;i++) {
		   pixmap.txt +=pstck[psp].x[i]+" "+pstck[psp].y[i]+",";}
		 pixmap.txt +="\"\n";
		 pixmap.txt +="style=\"";
		 if(stack[sp].c2>=0) {
		 pixmap.txt +="fill:"          +colours[stack[sp].c2]+"; ";
		 pixmap.txt +="fill-opacity:"  +alphas [stack[sp].c2]+"; ";}
		 pixmap.txt +="stroke-width:"          +stack[sp].w  +"; ";
		 pixmap.txt +="stroke:"        +colours[stack[sp].c] +"; ";
		 pixmap.txt +="stroke-opacity:"+alphas [stack[sp].c];
		 pixmap.txt +="\">\n";
		 pixmap.txt +="</polygon></g>\n";
	       }
	       else {
	       if(!pixmap.polygon) pixmap.polygon = new Array();
	       var n = pixmap.polygon.length;
	       pixmap.polygon[n] = new Object;
	       pixmap.polygon[n].line = pstck[psp].c;
	       pixmap.polygon[n].fill = stack[sp].c2,
	       pixmap.polygon[n].x    = pstck[psp].x;
	       pixmap.polygon[n].y    = pstck[psp].y;
	       }//endif SVG
//defaultStatus += " "+psp+"}"+pixmap.polygon[n].x.length+","+n;
//defaultStatus += ","+pixmap.polygon[n].line+","+pixmap.polygon[n].fill;
	       if(psp>0) --psp;
	       break;}
	    case "'": 
	       if(stack[sp].c<ncolours-1) stack[sp].c++; 
	       stack[sp].c2 = (stack[sp].c2+1)%ncolours; //fill may != c
	       break;
	    case "`": 
	       if(stack[sp].c>0) stack[sp].c--;
	       else              stack[sp].c = ncolours-1;
	       stack[sp].c2 = (stack[sp].c2-1)%ncolours;
	       break;
	    case "%": {/* cutoff */
	       var l_ = l+1;
	       var c;
	       while((l_<commands.length) &&(c = commands.charAt(l_))!="]"){
	         if(c=="}") {if(psp>0) --psp;} /*pop polygon but dont draw it*/
	         l=l_; l_++;
	       }
	       break;}
	    case "|": /* Reverse direction (ie: turn by 180 degrees) */
	       stack[sp].a += 180;
	       break;
	    case "#": /* Increment the line width by line width increment */
	       stack[sp].w *= params.wf; //use factor
	       break;
	    case "!": /* Decrement the line width by line width increment */
	       stack[sp].w /= params.wf; //use factor
	       break;
	    case ">": /* Multiply the line length by the line length scale factor */
	       stack[sp].sc *= params.sf; 
	       break;
	    case "<": /* Divide the line length by the line length scale factor */
	       stack[sp].sc /= params.sf; 
	       break;
	    case "(": /* Decrement turning angle by turning angle increment */
	       stack[sp].deg -= params.vf; 
	       break;
	    case ")": /* Decrement turning angle by turning angle increment */
	       stack[sp].deg += params.vf; 
	       break;
	    case "@": /* Draw a dot with line width radius */
		if(svgcomment) {
		  var x = stack[sp].x;
		  var y = stack[sp].y;
		  var w = stack[sp].w;
		  pixmap.txt +="<g id=\"C"+l+"\">\n";
		  pixmap.txt +="<circle"+
			       " cx=\""+x+"\""+
		               " cy=\""+y+"\""+
			       " r=\"" +w+"\"";
		  if(stack[sp].c2>=0)
		  pixmap.txt +=" fill=\""          +colours[stack[sp].c2]+"\""+
			       " fill-opacity=\""  +alphas [stack[sp].c2]+"\"";
		  pixmap.txt +=" stroke=\""        +colours[stack[sp].c ]+"\""+
			       " stroke-opacity=\""+alphas [stack[sp].c ]+"\""+
			       " stroke-width=\"1\"/>\n";
		  pixmap.txt +="</g>\n";
		  set_bounds(x-w,y-w,pixmap);
		  set_bounds(x+w,y-w,pixmap);
		  set_bounds(x-w,y+w,pixmap);
		  set_bounds(x+w,y+w,pixmap);
		}
	        else { /* width only supported by SVG. So assume w=1 */
		  var x_ = Math.round(stack[sp].x);
		  var y_ = Math.round(stack[sp].y);
		  if(pixmap[y_]==null) {pixmap[y_] = new Array;}
	          pixmap[y_][x_] = stack[sp].c;
		  set_bounds(x_,y_,pixmap);
		  } //endif SVG
	       break;
	    default: /* do nothing*/
            //missing three-d ~(predefined graphics) &
        }//end switch c
	if((time++)%100==0 && timeout(timeout_start)) {
	  timedout |= 2;
	  return headandtail(pixmap,timeout_start,svgcomment);
	}
    }//endfor
return headandtail(pixmap,timeout_start,svgcomment);
}

function headandtail(pixmap,timeout_start,svgcomment) {
if(svgcomment) {
 var width  = 1+pixmap.maxx-pixmap.minx;
 var height = 1+pixmap.maxy-pixmap.miny;
/*
pixmap.txt +="<g id=\"F"+0+"\">\n";
pixmap.txt +="<line class=\"F\" ";
pixmap.txt +="x1=\""+pixmap.minx+"\" y1=\""+pixmap.miny+"\" ";
pixmap.txt +="x2=\""+pixmap.maxx+"\" y2=\""+pixmap.maxy+"\" ";
pixmap.txt +="style=\"stroke:red\">\n";
pixmap.txt +="</line>\n";
pixmap.txt +="</g>\n";
*/
var txt="";
txt +="<?xml version=\"1.0\"?>\n";
txt +="<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.0//EN\"\n";
txt +="\"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\n";
txt +="<svg xmlns=\"http://www.w3.org/2000/svg\" ";
//txt +=" width=\""+width+"px\" ";
//txt +="height=\""+height+"px\" ";
//txt +="viewBox=\"0 0 "+width+" "+height+"\";
txt +=">\n";
txt +="<title>Pfeiffer ";
txt +="http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer.html";
txt +="</title>\n";
txt +="<desc>Evolved Lindenmayer System</desc>\n";
//Avoid "--" confusing XML parser
txt +="<!--"+svgcomment.replace(/--/g,"__")+" -->\n";
if(timedout!=0) txt += "<!-- timedout="+timedout+" -->\n";
txt +="<!--created "+Date()+"-->\n";
var now = new Date().getTime();
txt +="<!--SVG generation took "+(now-timeout_start)+"ms -->\n";
txt +="<!--Logo bounding box "+pixmap.minx+" "+pixmap.miny+" "+pixmap.maxx+" "+pixmap.maxy+" -->\n";
txt +="<g id=\"top\" ";
txt +="transform=\"translate("+(-pixmap.minx)+","+pixmap.maxy+") ";
txt +="scale(1,-1)\">\n";
pixmap.txt = txt+pixmap.txt+"</g>\n</svg>\n";
}//endif svgcomment
    return pixmap;
}


//angle and step side used elsewhere
function D01(it,start,rules) {
    var timeout_start = new Date().getTime();
    var time=0;
    expansion=start;
    for(var i=0; i<it; i++) {
	var newstr = "";
	var size = 0;
	for(var l=0; l<expansion.length; l++) {
	    var c = expansion.charAt(l);
	    if(rules[c]!=null) c = rules[c];
	    newstr += c;
	    if((time++)%100==0 && timeout(timeout_start)) {
	      timedout |= 1;
	      return expansion;
	    }
	}
	expansion = newstr;
    }
    return expansion;
}//end D01
