// Pfeiffer Display Window #$Revision: 1.46 $
// W. B. Langdon
// http://www.cs.ucl.ac.uk/staff/W.Langdon
// Written on Jan 2004

//WBL 24 Nov 2005 Support w,wf,sf,vf (for SVG)
//                Ensure report F.side not .sc
//WBL 29 Aug 2005 Add autocomplete="OFF" to work around
//		  https://bugzilla.mozilla.org/show_bug.cgi?id=236791

//WBL  7 Aug 2005 Add support for SVG

var w;
var total;
var warning;
var last_idx = new Array();

function Value(I,field) {
  var FI=field+I;
  return w.document.outputs[FI].value;
}
function ValueF(I,field,F) {
  F[field] = Value(I,field);
}
function ValueNum(I,field,F) {
  F[field] = parseFloat(Value(I,field));
}
function display(I,field,value) {
  if(value==null) return;
  var FI=field+I;
  if((""+value).search(/\./)==-1) 
    w.document.outputs[FI].value = value;
  else {
    var width = (w.document.outputs[FI].size)? w.document.outputs[FI].size : 8;
    w.document.outputs[FI].value = FtoString(value,width);
  }//endelse decimal point
}
function displayStr(I,field,value) {
  if(value==null) return;
  var FI=field+I;
  w.document.outputs[FI].value = value;
}
function displayF(I,F,field) {
  display(I,field,F[field]);
}
function displayL(I,field) {
  displayF(I,Flake[I],field);
}
function displayC(I,field,colours) {
  if(colours==null) return;
  var FI=field+I;
  if(!w.document.outputs[FI]) return;
  var t = "";
  for(var j=0;j<colours.length;j++) {
    t +="#";
    for(var k=0;k<3;k++) {
      var c = colours[j][k];
      if(c<16) t +="0";
      t += c.toString(16);
    }
    t +=" ";
  }
  w.document.outputs[FI].value = t;
}
//BUG in Deerpark's SVC?????
//https://bugzilla.mozilla.org/show_bug.cgi?id=290770
//https://bugzilla.mozilla.org/show_bug.cgi?id=299153 something similar
//https://bugzilla.mozilla.org/show_bug.cgi?id=296018 not calling ImageURIChanged
//Reported 11 Aug as https://bugzilla.mozilla.org/show_bug.cgi?id=304334
var flk_usage = new Array();
function displayTxtPic(I,txt,colour) {
  if(!flk_usage[I]) flk_usage[I]=0;
//if(flk_usage[I]==1) {
//  w.alert("Possible problem re-displaying SVG "+
//  I+" "+flk_usage[I]+", cf bugzilla 304334");}
  flk_usage[I]++;
  tt = image_txt(I,txt,colour);
  w.document.getElementById("flk"+I).innerHTML = tt;
}
function displayPic(I) {
//  alert("displayPic("+I+") idx="+picture[I].idx+" last_idx="+last_idx[I]+
//" ns6up="+ns6up+" picture["+I+"].complete="+picture[I].complete);//+" xbm["+picture[I].idx+"].txt="+xbm[picture[I].idx].txt.length);

  if(ns4up) return true; //NS4 dont bother supporting second picture

  if(picture[I].idx==last_idx[I]) return true; //already on display

  //WARNING when IE etc fails to display flake .complete is never set
  //so causing CPU hogging loops due to display_flake called excessively
  if((!(ns6up && xbm[picture[I].idx].txt)) && (!picture[I].complete))
    return false;                              //picture not ready
  last_idx[I] = picture[I].idx;                //remember what is on display

  w.defaultStatus += "("+I+" "+age[I]+" "+picture[I].idx;
  if(ie4up) {//IE5 javascript: operates in context of "w..images[..]"
    w.document.images["idot"+I].src="javascript:window.opener.xbm["+picture[I].idx+"]";
  }else {
    if (ns6up && xbm[picture[I].idx].txt)
      displayTxtPic(I,xbm[picture[I].idx].txt,"WHITE");
    else {
    //It appears firefox SVG deletes images[idotnn] if nn reverts to XBM
    //No fix yet, instead trap but don't report error.
      if(w.document.images["idot"+I]) {
      //Mozilla caching. string must be identical
      w.document.images["idot"+I].src="javascript:xbm["+picture[I].idx+"]";
      }
    }//endif SVG
  }
  w.defaultStatus += ")";
  return true;
}
function nsetString(nset) {
    return (nset)? (nset.join? nset.join() : ""+nset) : "";
}
function bool(value) { return value? "Y":""; }
function  num(value) { return (value!=0)? value:""; }
function display_flake(I) {
    //dont disply is screen is gone or is iconised
    if(!w||w.closed||iconised(w)) return false;
    display(I,"age",age[I]);
    if(ns4up) display(I,"saved",saved[I]);
    display(I,"partner",partner[I]);
    display(I,"deleted",bool(deleted[I]));
    display(I,"ctime", ctime[I]);
    display(I,"fit",   fit[I].value);
    display(I,"last",  fit[I].last);
    display(I,"min",   fit[I].min);
    display(I,"sex",   fit[I].sex);
    display(I,"childs",fit[I].childs);
    displayL(I,"it");
    displayStr(I,"str",Flake[I].str);
    displayL(I,"v");
    displayL(I,"side");
/*SVG only*/
    displayL(I,"w");
    displayL(I,"wf");
    displayL(I,"sf");
    displayL(I,"vf");
/**/
    displayStr(I,"rules",Flake[I].rules_);
    displayC(I,"colours",Flake[I].colours);
    displayL(I,"width");
    displayL(I,"height");
    displayL(I,"time");
    displayStr(I,"nset",nsetString(Flake[I].nset));
    display(I,"a",axis[I].a);
    display(I,"x",axis[I].x);
    display(I,"y",axis[I].y);
    display(I,"z",axis[I].z);
    display(I,"glen",  num(chrome[I].length));
    displayStr(I,"chrome",chrome[I]);
    if(Flake[I].cmds) display(I,"plen",Flake[I].cmds.length);
    displayStr(I,"cmds",Flake[I].cmds);
    w.document.outputs.total.value=++total;

    if(picture[I].idx<0) return true;           //not a valid picture
    if((!ie4up) && age[I]<=cwait) return false; //let main window go first
    if(w.defaultStatus.length>80) w.defaultStatus = w.defaultStatus.slice(20);
    return displayPic(I);
}

function display_reset() {//appears to be called only by IE5? & create_display
    //alert("display_reset");
    for(var i=0; i<no; i++) {
      delete last_idx[i];
      if(display_flake(i)) change_display[i] = false;
    }
}

function write_heading() {
  w.document.write("<tr>"+
    "<th></th>"+
    "<th>age (ticks)</th>"+
    ((ns4up)? "<th>saved</th>" : "")+
    "<th>partner</th>"+
    "<th>deleted</th>"+
    "<th>ctime</th>"+
    "<th>fitness</th>"+
    "<th>last guy</th>"+
    "<th>min fit</th>"+
    "<th>sex</th>"+
    "<th>childs</th>"+
    "<th bgcolor=blue>it</th>"+
    "<th bgcolor=blue>Start</th>"+
    "<th bgcolor=blue>Angle</th>"+
    "<th bgcolor=blue>Side</th>"+
    "<th bgcolor=navy>w</th>"+
    "<th bgcolor=navy>wf</th>"+
    "<th bgcolor=navy>sf</th>"+
    "<th bgcolor=navy>vf</th>"+
    "<th bgcolor=blue>rules</th>"+
  ((window.colour_map)? "<th bgcolor=blue>colours</th>" : "")+
    "<th>width</th>"+
    "<th>height</th>"+
    "<th>time</th>"+
    "<th>nset</th>"+
    "<th>Angle</th>"+
    "<th>x</th>"+
    "<th>y</th>"+
    "<th>z</th>");
  if(!ns4up){  w.document.write("<th>picture</th>");}
  w.document.write(
    "<th>G len</th>"+
    "<th bgcolor=blue>Chromosome</th>"+
    "<th>P len</th>"+
    "<th bgcolor=blue>Drawing commands</th>"+
    "</tr>\n");
}
//create display window
//We get a security problem
//---http://www.talkaboutprogramming.com/group/comp.lang.javascript/messages/415751.html
//but appear to be able to ignore it (at least in Mozilla Firebird)
//var win1 = window.open("","Window-1","height=300,width=400,menuvar=no,scrollbars=no,statusbar=no");

//http://developer.netscape.com/support/faqs/champions/javascript.html ONFOCUS="this.blur()"

function create_display() {
  if((w) && (!w.closed) && (!confirm("Start new display table?"))) return;

  w = window.open();
  if (w==null) {
    document.writeln("Could not open display window. Did you block pop ups?<br>");
  }
  else {
  total = 0;
  warning = 0;

  w.document.open("text/html");
  w.document.write("<html><head><title>Table of Pfeiffer Data</title></head>");
  w.document.write("<body bgcolor=\"#808080\" onload=\"window.opener.display_reset()\">")
  w.document.write("<form name=\"outputs\">");
  w.document.write("<tt><table>");
  for (var i = 0; i < no; ++ i) {  
    if(i%10==0) write_heading();
    w.document.write("<tr>");
    w.document.write("<td>"+i+"</td>");
    w.document.write("<td><input type=text name=\"age"+i+"\" size=6 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    if(ns4up) w.document.write("<td><input type=text name=\"saved"+i+"\" size=1 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"partner"+i+"\" size=2 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"deleted"+i+"\" size=1 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"ctime"+i+"\" size=6 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"fit"+i+"\" size=8 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"last"+i+"\" size=2 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"min"+i+"\" size=8 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"sex"+i+"\" size=2 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"childs"+i+"\" size=2 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"it"+i+"\" size=1"+ 
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"str"+i+"\" size=20"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"v"+i+"\" size=3"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"side"+i+"\" size=4"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
/*SVG only*/
    w.document.write("<td bgcolor=navy><input type=text name=\"w"+i+"\" size=1"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td bgcolor=navy><input type=text name=\"wf"+i+"\" size=7"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td bgcolor=navy><input type=text name=\"sf"+i+"\" size=7"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td bgcolor=navy><input type=text name=\"vf"+i+"\" size=2"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
/**/
    w.document.write("<td bgcolor=blue><input type=text name=\"rules"+i+"\" size=20"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
  if(window.colour_map) 
    w.document.write("<td bgcolor=blue><input type=text name=\"colours"+i+"\" size=20"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_flake("+i+")\"></td>");
    w.document.write("<td><input type=text name=\"width"+i+"\" size=3 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"height"+i+"\" size=3 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td><input type=text name=\"time"+i+"\" size=5 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
  if(window.colour_map) 
    w.document.write("<td><input type=text name=\"nset"+i+"\" size=20 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
  else
    w.document.write("<td><input type=text name=\"nset"+i+"\" size=4 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"a"+i+"\" size=5"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_axis("+i+")\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"x"+i+"\" size=5"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_axis("+i+")\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"y"+i+"\" size=5"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_axis("+i+")\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"z"+i+"\" size=5"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_axis("+i+")\"></td>");

//    w.document.write("<td><input type=textarea name=\"src"+i+"\" size=7 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    if (!ns4up) {//NS4 dont bother supporting second picture
    w.document.write("<td id=\"flk"+ i +"\">"+
		     image_txt(i,defaultflake,"WHITE")+
//                   "<img name=\"flk"+i+"\" src=\""+defaultflake+"\""+
		     "</td>");
    }
    w.document.write("<td><input type=text name=\"glen"+i+"\" size=3 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"chrome"+i+"\" size=60"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_chrome("+i+")\"></td>");
    w.document.write("<td><input type=text name=\"plen"+i+"\" size=3 onfocus=\"this.blur()\" autocomplete=\"OFF\"></td>");
    w.document.write("<td bgcolor=blue><input type=text name=\"cmds"+i+"\" size=60"+
		     " autocomplete=\"OFF\" "+
                     " onchange=\"window.opener.renew_cmds("+i+")\"></td>");
    w.document.write("</tr>\n");
  }//end loop i

  w.document.write("</table></tt>");
  w.document.write("<p><input type=text name=\"total\" size=6>"+
                   " screen updates");
  w.document.write("</form>");
  w.document.write("<address>");
  w.document.write("<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/\">W.B.Langdon</a> ");
  w.document.write("$Revision: 1.46 $ ");
  w.document.write(new Date().toLocaleString());
  w.document.write("</address>")
  w.document.write("</body></html>\n")
  }

  //http://devedge.netscape.com/library/manuals/2000/javascript/1.5/reference/function.html

  display_reset();
  return w;
}//end create_display

function display_chrome(I,F) {
  displayF(I,F,"it");
  displayStr(I,"str",F.str);
  displayF(I,F,"v");
  displayF(I,F,"side");
  displayF(I,F,"w");
  displayF(I,F,"wf");
  displayF(I,F,"sf");
  displayF(I,F,"vf");
  displayStr(I,"rules",F.rules_);
  displayC(I,"colours",F.colours);
  display (I,"glen", num(Value(I,"chrome").length));
}

function renew_chrome2(I,F) {
  if(window.colour_map) colour_map(Value(I,"chrome"),F);
  parse_chrome(Value(I,"chrome"),F);
  display_chrome(I,F);
}

function renew_flake2(I,F) {
  ValueNum(I,"it",  F);
  ValueF  (I,"str", F);
  ValueNum(I,"v",   F);
  ValueNum(I,"side",F);
  ValueNum(I,"w",F);
  ValueNum(I,"wf",F);
  ValueNum(I,"sf",F);
  ValueNum(I,"vf",F);
  var t = Value(I,"rules").replace(/=>/g,",");
  F.rules=new Object();
  parse_rules(t,F);
  //Koch snefnug
  if(F.rulesset==0) {F.rules['F'] = 'F-F++F-F';}
  format_rules_(F);
  if(window.colour_map) colour_map(Value(I,"colours"),F);
  display_chrome(I,F);

  var start = new Date().getTime();
  F.cmds  = D01(F.it,F.str,F.rules,limit.value);
  w.defaultStatus += " "+F.cmds.length;
  var now = new Date().getTime();
  F.time = now - start;
  display(I,"plen",F.cmds.length);
  displayStr(I,"cmds",F.cmds);
}

function read_axis(I) {
  var X = new Object();

  ValueNum(I,"a",X);
  ValueNum(I,"x",X);
  ValueNum(I,"y",X);
  ValueNum(I,"z",X);

  //F.a = 0; F.x=0; F.y=0; F.z=1;

  displayF(I,X,"a");
  displayF(I,X,"y");
  displayF(I,X,"x");
  displayF(I,X,"z");

  if( isNaN(X.a) || isNaN(X.x) || isNaN(X.y) || isNaN(X.z) ||
     (X.x==0 && X.y==0 && X.z==0)) {
    w.alert("Bad angle or axis -- ignored")
    return;   
  }
  X.da = (0.5-Math.random())*60;
  return X;
}

function renew_cmds2(I,F,png_) {
  ValueNum(I,"v",   F);
  ValueNum(I,"side",F);
  ValueNum(I,"w",F);
  ValueNum(I,"wf",F);
  ValueNum(I,"sf",F);
  ValueNum(I,"vf",F);
  ValueF  (I,"cmds",F);
  display(I,"plen",F.cmds.length);
  if(window.colour_map) colour_map(Value(I,"colours"),F);

  var X = read_axis(I); if(!X) return;

  //Re-use picture on main screen
  var J = parseInt(I);
  //ensure we get a unique string for .src
  F.n = xbm.length;
  var start = new Date().getTime();

  if(png_==SVG) {
    var comment = Value(J,"chrome")+":_;"+"USER;"+
		  "v="+F.v+";str="+F.str+";"+
		  "it="+F.it+";side="+F.side+";"+
		  "w="+F.w+";wf="+F.wf+";sf="+F.sf+";vf="+F.vf+";"+
		  "rules=("+F.rules_+");"+
		  (F.str? "len="+F.str.length+";" : ""+
		  "svg["+F.n+"];"+J+";");

    F.pixmap = evalstring(F,F.cmds,F.colours,comment);

    X.x=0; X.y=0; X.z=1; //only z-axis rotation supported as yet by SVG
    displayF(J,X,"y");
    displayF(J,X,"x");
    displayF(J,X,"z");
    xbm[F.n] = rotate_svg(F.pixmap,X.a);

    //nset not set up for SVG, so fitness=0
    F.nset   = new Array(); 
    F.width  = 1+xbm[F.n].maxx-xbm[F.n].minx;
    F.height = 1+xbm[F.n].maxy-xbm[F.n].miny;
    //Re-use main window. Klundge.
    Flake[J].width  = F.width;
    Flake[J].height = F.height;
    displayTxtPic(J,xbm[F.n].txt,"BLUE");
  } else {
  //garbage collect xbm
  var old = picture[J].idx;
  if(old>=0) delete xbm[old]; //garbage colletion

  var M = glRotate(X.a,X.x,X.y,X.z);
  F.pixmap = evalstring(F,F.cmds,(png_)? F.colours : new Array(2),"");
  var newpix = rotate(F.pixmap,M);
  xbm[F.n] = (png_)? png_pixmap(newpix,F,F.colours) : xbm_pixmap(newpix,F);
  w.defaultStatus += F.width+"x"+F.height;
  w.defaultStatus += " n"+F.n;
  picture[J].src  = "javascript:xbm["+F.n+"]"; //weird caching effects!!
  picture[J].idx  = F.n;
  w.defaultStatus += " l"+xbm[picture[J].idx].length;
  w.defaultStatus += (picture[J].complete==true)? "c":"K";

  var txt = image_txt(J,"javascript:xbm["+picture[J].idx+"]","BLUE");
  pictureo[J].last = F.n;
  if (ns4up) {
    document.layers["dot"+J].src = "javascript:"+
                        "image_txt("+J+",\"javascript:xbm["+F.n+"]\",\"BLUE\")";
  }else if (ie4up) {
    document.all["dot"+J].innerHTML = txt;
  }else if (ns6up) {
    document.getElementById("dot"+J).innerHTML = txt;
  }      
  displayPic(J);
  }//else not SVG

  F.max_width  = F.width;
  F.max_height = F.height;

  var now = new Date().getTime();
  F.time  += now - start;
  w.defaultStatus += " nset("+nsetString(F.nset)+")";
  F.fit    = fitness(F.width,F.height,F.nset);
  w.defaultStatus += " "+Math.round(F.fit)+" "+
                     ((new Date().getTime())-start)+"mS ";

  displayF(I,F,"width");
  displayF(I,F,"height");
  displayF(I,F,"time");
  displayStr(I,"nset",nsetString(F.nset));
  displayF(I,F,"fit");

  display(I,"age",Value(I,"age")+">");
}

function renew_chrome(I) {
  w.defaultStatus = "<chrome ";
  //I = parseFloat(I);
  if((!document.controls.elements.run[1].checked) && warning==0) {
    warning++;
    alert("renew_chrome("+I+"). Perhaps you should pause the simulation?");}
  display(I,"age","+"+Value(I,"age"));
  var F = new Object();
  renew_chrome2(I,F);
  renew_flake2(I,F);
  var png_ = png;
  renew_cmds2(I,F,png_);
  if(w.confirm('Load _Chromosome_('+I+') into simulation?')) {
    //unlike xbm and png only update SVG in main window if asked to
    if(xbm[F.n].txt) {
      var old = picture[I].idx;
      if(old>=0 && old<(xbm.length-1)) delete xbm[old]; //garbage colletion
      picture[I].idx   = F.n;
      pictureo[I].last = F.n;
      if(ns6up) {
        var txt = image_txt(I,xbm[F.n].txt,"BLUE",F.width,F.height);
	document.getElementById("dot"+I).innerHTML = txt;
      }
    }//endif SVG

    copyflake(I,Value(I,"chrome"),F,maturity.value+1);
    clear_twistcache(I);
    newfit(I,F.fit);
    text[I]	      =	"Loaded by user";    
    //log nospaces in URL
    var url = logurl+cleanchrome(chrome[I])+":_;"+"USER;"+
	          "v="+F.v+";str="+F.str+";"+
		  "it="+F.it+";side="+F.side+";"+
		  "w="+F.w+";wf="+F.wf+";sf="+F.sf+";vf="+F.vf+";"+
		  "rules=("+F.rules_+");len="+F.str.length+";"+
		  "elapsed="+F.time+";w="+F.width+";h="+F.height+";"+
		  "nset="+nsetString(F.nset)+
		  ";to="+timedout+";"+I+";"+
		  ((png_==true)? "png":"xbm")+"["+F.n+"]";
    fetchURL(url);
  }
  w.defaultStatus += "chrome>";
}

function renew_flake(I) {
  w.defaultStatus = "<flake ";
  //I = parseFloat(I);
  if((!document.controls.elements.run[1].checked) && warning==0) {
    warning++;
    alert("renew_flake("+I+"). Perhaps you should pause the simulation?");}
  display(I,"age","-"+Value(I,"age"));
  var F = new Object();
  renew_flake2(I,F);
  renew_cmds2(I,F,png);
  w.defaultStatus += "flake>";
}

function renew_cmds(I) {
  w.defaultStatus = "<cmds ";
  //I = parseFloat(I);
  if((!document.controls.elements.run[1].checked) && warning==0) {
    warning++;
    alert("renew_cmds("+I+"). Perhaps you should pause the simulation?");}
  display(I,"age","<"+Value(I,"age"));
  var F = new Object();
  renew_cmds2(I,F,png);
  w.defaultStatus += "cmds>";
}

function renew_axis(I) {
  w.defaultStatus = "<axis ";
  //I = parseFloat(I);
  if((!document.controls.elements.run[1].checked) && warning==0) {
    warning++;
    alert("renew_axis("+I+"). Perhaps you should pause the simulation?");}
  display(I,"age","."+Value(I,"age"));

  var X = read_axis(I); if(!X) return;
  var F = new Object();
//  renew_flake2(I,F);
  renew_cmds2(I,F,png);
  if(w.confirm('Load axis('+I+') into simulation?')) { 
    axis[I] = X; 
    clear_twistcache(I);
  }
  w.defaultStatus += "axis>";
}


